
      include 'O8BLOC.INC'

      integer nx00, nc00, neqc00
      parameter(nx00=2, nc00=5, neqc00=1)

      integer ISEED1, ISEED2
      real begt, endt, x0RANMAR, tarray(2), etime, dtime

      integer nxx, nc, neqc, nineqc
      common /prbSQP/nxx,nc,neqc,nineqc

      data del0/1.00d2/, tau0/1.d4/, tau/.1d0/

      integer i, ierr, niter, mstart
      integer iter, nsucc, ni_used 
      double precision xy(nx)
      double precision oobj, vviomax
      double precision topobj, avgobj, botobj, vl, xobj, lb(nx), ub(nx)

c   For discrete or mixed-integer problem
      logical hasdiscrete
      double precision rleq
      common /hhasdiscrete/ hasdiscrete, rleq
      integer isdx(nx), ns
      double precision xstep(nx), xirange, nis, Dint

      double precision slobj
      common /slobj/ slobj

      logical used
      character*20 filename

c   initialize problem-dependent data for SQP
      call init_SQP_pd()

      print *, "Input scale slobj for obj (obj/slobj) ="
      read *, slobj

      begt=etime(tarray)

      n=nx00
      nh=neqc00
      ng=nc00-neqc00

      nxx = n
      nc = nh+ng
      neqc = nh
      nineqc = ng

      print *, "Multi start /(0,1)"
      read *, mstart
      if(mstart.EQ.1) then
         print *, "Input number of runs = "
         read *, niter
         if(niter.LT.1) then
             print *, "Wrong run number in SQPmain !"
             stop
         endif
      else if(mstart.NE.0) then
         print *, "Wrong running mode in SQPmain !"
         stop
      endif

      call xxbound(nx,lb,ub)
      call xxdiscrete(nx,isdx)
      ns=10000
      rleq=0.001D0
      hasdiscrete=.FALSE.
      do 20 i=1,n
          xirange=ub(i)-lb(i)
          if(xirange.LT.1.0D0) then
              nis=ns
          else
              nis=Dint(xirange*ns+1.0D-6)
          endif
          if(isdx(i).EQ.1) then
              hasdiscrete=.TRUE.
              xstep(i)=xirange/(nis-1.0D0)
          else
              xstep(i)=0.0D0
          endif
20    continue
      print *, "hasdiscrete = ", hasdiscrete, "   nsample = ", ns
      print *, " "

      if(mstart.EQ.0) then
          print *, "Input file name for starting point:"
          read *, filename
          inquire(file=filename, exist=used)
          if(used) then
              open(unit = 20, file = filename, status='old', iostat=ierr)
              if(ierr.ne.0) print *, "Open file ",filename, " error ",ierr
              read (20,*) (xy(i), i=1,n)
              close(unit = 20)
          else
              print*, "File ", filename, " doesn't exist!"
              stop
          endif

          print *,'Start obj=',oobj(n,xy), '  Start maxVio=', vviomax(n,xy)
          print *,'Start x=', (xy(i),i=1,n)
          print *,' '

          begt=dtime(tarray)
          call by_donlp2(ni_used,xy)
          if(hasdiscrete) then
              do 21 i=1,n
                  if(isdx(i).EQ.1) xy(i)=Dint((xy(i)-lb(i))/xstep(i))*xstep(i)+lb(i)
21            continue
          endif
          endt=dtime(tarray)

          if(SILENT) then
            vl=vviomax(n,xy)
            if(vl.LT.1.0D-5) then
              xobj=oobj(n,xy)
              print *,'Final Obj=',xobj, '  maxVio=', vl, '  #Iter=',ni_used
              print *,'Final x=', (xy(i),i=1,n)
              print *, "run_id =", 1, " : obj =", xobj, " time =", endt
            else
              print *,'SQP Obj fails, vio = ', vl
              print *, "run_id =", 1, " : obj =", (1.0D20), " time =", endt
            endif
          endif

          stop
      endif


C   Set random generator for starting points x 
      ISEED1=1
      ISEED2=2
      CALL x0RMARIN(ISEED1,ISEED2)

      topobj=1.0D20
      avgobj=0.0D0
      botobj=(-1.0D20)
      nsucc=0

      do 50 iter = 1, niter
         print *, " "
         print *, "Random starting points set #",iter

         do 25 i=1,n
             xy(i)=lb(i)+(ub(i)-lb(i))*x0RANMAR()
25       continue

         print *,'Start obj=',oobj(n,xy), '  Start maxVio=', vviomax(n,xy)
         print *,'Start x=', (xy(i),i=1,n)
         print *,' '

c         do 26 i=1,n
c             print *, "SQP", iter, "  x0=", xy(i)
c26       continue
c         goto 50

c        noiter indicates the maximum iteration number of donlp2,

         begt=dtime(tarray)
         call by_donlp2(ni_used,xy)
         if(hasdiscrete) then
             do 22 i=1,n
                 if(isdx(i).EQ.1) xy(i)=Dint((xy(i)-lb(i))/xstep(i))*xstep(i)+lb(i)
22           continue
         endif
         endt=dtime(tarray)

         if(SILENT) then
            vl=vviomax(n,xy)
            if(vl.LT.1.0D-5) then
              nsucc=nsucc+1
              xobj=oobj(n,xy)
              if(xobj.LT.topobj) topobj=xobj
              if(xobj.GT.botobj) botobj=xobj
              avgobj=avgobj+xobj
              print *,'Final Obj=',xobj, ' maxVio=', vl, ' #Iter=',ni_used
              print *,'Final x=', (xy(i),i=1,n)
              print *, "run_id =", iter, " : obj =", xobj, " time =", endt
            else
              print *,'SQP Obj fails, vio = ', vl
              print *, "run_id =", iter, " : obj =", (1.0D20), " time =", endt
            endif
         endif
         call flush(6)

50    continue 

      if(niter.GT.1) then
         print *, "========== Obj Summary of ", niter," ========== "
         print *, " best Obj = ", topobj, ",  worst Obj = ", botobj
         print *, " avrg Obj = ", avgobj/nsucc
         print *, nsucc, " success run time per Obj = ", etime(tarray)/niter, " sec"
      endif

      stop
      end


      subroutine by_donlp2(ni_used,xy)
      integer ni_used
      double precision xy(*)

      include 'O8COMM.INC'

      integer noiter
      common /noiter/noiter

      integer isnumgrad
      common /isnumgrad/ isnumgrad

      logical hasdiscrete
      double precision rleq
      common /hhasdiscrete/ hasdiscrete, rleq

      integer nxx, nc, neqc, nineqc
      common /prbSQP/nxx,nc,neqc,nineqc

      integer i

      do 10 i=1,n
          x(i)=xy(i)
10    continue

      noiter=1000
      isnumgrad=0
      if(hasdiscrete.AND.neqc.GE.1) isnumgrad=1

      call donlp2
      ni_used=ITSTEP

      do 20 i=1,n
          xy(i)=x(i)
20    continue

      return
      end
c
c
c   vviomax(n,x): maximal unsatisfication of constraints
c       n --- variable dimension
c       x --- primary and dual variables
c
        double precision function vviomax(n,x)
        double precision x(*), Dabs, Dmax1
        double precision cceq, ccineq, val
        common /prbSQP/nx, nc, neqc, nineqc

        vviomax=0.0D0

        do 5 m=1,neqc
            val=Dabs(cceq(m,nx,x))
            if(val.GT.vviomax) vviomax=val
5       continue

        do 10 m=1,nineqc
            val=Dmax1(0.0D0,ccineq(m,nx,x))
            if(val.GT.vviomax) vviomax=val
10      continue

        return
        end

c
      SUBROUTINE SETUP0
      INCLUDE 'O8COMM.INC'
      integer j
c      ANALYT=.FALSE.
      ANALYT=.TRUE.
      EPSDIF=0.D0
      PROU=10
      MEU=20
      NRESET=N
c     SILENT=.FALSE.
      SILENT=.TRUE.
      do j=0,nh+ng
        gunit(1,j)=-1
        gunit(2,j)=0
        gunit(3,j)=0
      enddo
      RETURN
      END

c
c  used for generating starting points
c
      subroutine x0RMARIN(IJ,KL)
C NOTE: The seed variables can have values between:    0 <= IJ <= 31328
C                                                      0 <= KL <= 30081
      real U(97), C, CD, CM
      integer I97, J97
      common /x0raset1/ U, C, CD, CM, I97, J97
      if( IJ .lt. 0  .or.  IJ .gt. 31328  .or.
     *    KL .lt. 0  .or.  KL .gt. 30081 ) then
          print '(A)', ' The first random number seed must have a value
     *between 0 and 31328'
          print '(A)',' The second seed must have a value between 0 and
     *30081'
            stop
      endif
      i = mod(IJ/177, 177) + 2
      j = mod(IJ    , 177) + 2
      k = mod(KL/169, 178) + 1
      l = mod(KL,     169)
      do 2 ii = 1, 97
         s = 0.0
         t = 0.5
         do 3 jj = 1, 24
            m = mod(mod(i*j, 179)*k, 179)
            i = j
            j = k
            k = m
            l = mod(53*l+1, 169)
            if (mod(l*m, 64) .ge. 32) then
               s = s + t
            endif
            t = 0.5 * t
3        continue
         U(ii) = s
2     continue
      C = 362436.0 / 16777216.0
      CD = 7654321.0 / 16777216.0
      CM = 16777213.0 /16777216.0
      I97 = 97
      J97 = 33
      return
      end

      function x0ranmar()
      real U(97), C, CD, CM
      integer I97, J97
      common /x0raset1/ U, C, CD, CM, I97, J97
         uni = U(I97) - U(J97)
         if( uni .lt. 0.0 ) uni = uni + 1.0
         U(I97) = uni
         I97 = I97 - 1
         if(I97 .eq. 0) I97 = 97
         J97 = J97 - 1
         if(J97 .eq. 0) J97 = 97
         C = C - CD
         if( C .lt. 0.0 ) C = C + CM
         uni = uni - C
         if( uni .lt. 0.0 ) uni = uni + 1.0
         x0RANMAR = uni
      return
      END

