C  by_csa: x --- starting point; t --- initial temperature
C          rt --- ratio of reducing t

      subroutine by_csa(msol,xx,x,xobj,xvio,t0,rt)

      parameter(nx=2, nc=1, neqc=1, NEPS=4)
      parameter(nineqc=nc-neqc, neq=nx+nc)
      parameter(nprt=3, nchd=3)
      parameter(ntot=nprt+nchd)

      double precision xx(nprt,neq), x(*), xobj, xvio, t0, rt
      
      double precision  LB(nx), UB(nx), XOPT(neq), C(neq), VM(neq),
     1                  FSTAR(NEPS), XP(neq), EPS, FOPT

      INTEGER  NACP(neq), NS, NT, NFCNEV, IER, ISEED1, ISEED2,
     1         MAXEVL, IPRINT, NACC, NOBDS

      LOGICAL  MAX
      EXTERNAL FCN

      common /mSA/mSA
      double precision p, rleq, vtol
      common /penalty/ p
      common /rleq/ rleq
      common /vtol/ vtol

      logical hasdiscrete, needshift
      common /hasdiscrete/ hasdiscrete, needshift
      double precision xshift, xstep
      common /discrete/xshift(nx), xstep(nx)

      double precision sh_oviomax, sh_obj
      double precision rlambda(nc+1), stpobj, bstobj, stpvio, bstvio
      double precision rleq0, t
      double precision xt(neq)

c   for population SA
      double precision xxp(ntot,neq)

      t=t0
      p=1.0D0

      if(mSA.EQ.10) then
         rleq0=rleq
         vtol=1.0D-3
      else if(hasdiscrete) then
         vtol=1.0D-5
      else
         vtol=1.0D-5
      endif

      vtol=1.0D-10  

C  Set input parameters.
c      RT = 0.85D0
c      NT=10
      MAX = .FALSE.
      EPS = 1.0D-6
      ISEED1 = 1
      ISEED2 = 2

      NS=10
      if(100.GT.10*neq) then
          NT=100
      else
          NT=10*neq
      endif

      MAXEVL = 100 000 000 0
      IPRINT = 0
      call xbound(nx,LB,UB)
      DO 5 I=1,nx
         C(I) = 2.0D0
         VM(I)=0.1D0*(ub(i)-lb(i))
c         VM(I)=Min(1.0D0,(0.1D0*(ub(i)-lb(i))))
c         VM(I)=1.0D0
5     CONTINUE

         if(mSA.EQ.0) then
            CALL sa(NEQ,NC,rlambda,
     1           NX,X,MAX,RT,EPS,NS,NT,NEPS,MAXEVL,LB,UB,C,IPRINT,ISEED1,
     2           ISEED2,T,VM,XOPT,FOPT,NACC,NFCNEV,NOBDS,IER,
     3           FSTAR,XP,NACP)
         else if(mSA.EQ.1) then
c            NT=nprt*NT
            CALL psa(rlambda,
     1           NX,xx,MAX,RT,EPS,NS,NT,NEPS,MAXEVL,LB,UB,C,IPRINT,ISEED1,
     2           ISEED2,T,VM,XOPT,FOPT,NACC,NFCNEV,NOBDS,IER,
     3           FSTAR,xxp,NACP)
         else if(mSA.EQ.10) then
            CALL sa_equal(NEQ,NC,rlambda,xt,
     1           NX,X,MAX,RT,EPS,NS,NT,NEPS,MAXEVL,LB,UB,C,IPRINT,ISEED1,
     2           ISEED2,T,VM,XOPT,FOPT,NACC,NFCNEV,NOBDS,IER,
     3           FSTAR,XP,NACP)
            rleq=rleq0
         endif

         bstvio=sh_oviomax(xopt)
         if(bstvio.GT.vtol) then
            msol1=0
            if(mSA.NE.1) then
                stpvio=sh_oviomax(x)
                stpobj=sh_obj(nx,x)
                print *, "cSA: stop Obj = ", stpobj, "  maxVio = ", stpvio
                print *, "cSA: stop x = ", (x(i)+xshift(i),i=1,nx)
            else
                print *, "pSA fails"
            endif
         else
            msol1=1
            bstobj=sh_obj(nx,xopt)         
            do 10 i=1,neq
                x(i)=xopt(i)
10          continue
            print *, "cSA: Obj = ", bstobj, "  maxVio = ", bstvio
            print *, "cSA: x = ", (xopt(i)+xshift(i),i=1,nx)
         endif

         msol2=0
c         if(msol1.EQ.1) call by_DLM(msol2,x,xobj,xvio,ni_used)
c         if(msol1.EQ.1) then
c             if(hasdiscrete) then
c                 call by_DLM(msol2,x,xobj,xvio,ni_used)
c             else
c                 call by_donlp2(msol2,x,xobj,xvio,ni_used)
c             endif
c         endif

         if(msol2.EQ.1) then
             msol=1
             xidist=0.0D0
             do 40 i=1,nx
                if(abs(x(i)).LE.1.0D0) then
                    xidist=xidist+abs((x(i)-xopt(i)))
                else
                    xidist=xidist+abs((x(i)-xopt(i))/x(i))
                endif
40           continue

c             print *, "DLM: Obj =",xobj," vioMax =",xvio," #iter =",ni_used
c             print *, "DLM: x = ", (x(i)+xshift(i),i=1,nx)
c             if(hasdiscrete) then
c                 print *, "DLM: Obj =",xobj," vioMax =",xvio," #iter =",ni_used
c                 print *, "DLM: x = ", (x(i)+xshift(i),i=1,nx)
c             else
c                 print *, "SQP: Obj =",xobj," vioMax =",xvio," #iter =",ni_used
c                 print *, "SQP: x = ", (x(i),i=1,nx)
c             endif
c             print *, "xi distance = ", xidist/nx

             if(bstobj.LT.xobj) then
                xobj=bstobj
                xvio=bstvio
             endif
         else if(msol1.EQ.1) then
             msol=1
             xobj=bstobj
             xvio=bstvio
             do 15 i=1,neq
                x(i)=xopt(i)
15           continue
c             print *, "DLM: Obj fail"
c             if(hasdiscrete) then
c                 print *, "DLM: Obj fail"
c             else
c                 print *, "SQP: Obj fail"
c             endif
         else
             msol=0
         endif

      return
      END

c 
c  fcn(nx,x,f): interface for SA's objective
c
      subroutine fcn(nx,x,f)
      double precision x(*), f

      double precision sh_dlag

      f=sh_dlag(x)

      return
      end

