C  by_mcsa: x0 --- starting point; t0 --- initial temperature
C          rt --- ratio of reducing t

      subroutine by_mcsa(msol,nNT,xx0,x0,xobj,xvio,t0,rt)

      parameter(nx=2, nc=1, neqc=1, NEPS=4)
      parameter(nineqc=nc-neqc, neq=nx+nc)
      parameter(nprt=3, nchd=3)
      parameter(ntot=nprt+nchd)
      
      double precision xx0(nprt,neq), x0(*), xobj, xvio, t0, rt

      double precision  LB(nx), UB(nx), XOPT(neq), C(neq), VM(neq),
     1                  FSTAR(NEPS), XP(neq), EPS, FOPT, x(neq)

      INTEGER  NACP(neq), NS, NT, NFCNEV, IER, ISEED1, ISEED2,
     1         MAXEVL, IPRINT, NACC, NOBDS

      LOGICAL  MAX
      EXTERNAL FCN

      logical onegood

      common /mSA/mSA
      double precision p, rleq, vtol
      common /penalty/ p
      common /rleq/ rleq
      common /vtol/ vtol

      logical hasdiscrete, needshift
      common /hasdiscrete/ hasdiscrete, needshift
      double precision xshift, xstep
      common /discrete/xshift(nx), xstep(nx)

      double precision sh_oviomax, sh_obj
      double precision rlambda(nc+1), bstobj, bstvio
      double precision rleq0, t

      double precision rtobj, rtvio, rtx(neq), dxobj
      double precision xidist, xt(neq)

c   for population SA
      double precision xx(nprt,neq), xxp(ntot,neq)

      p=1.0D0
      if(mSA.EQ.10) then
          rleq0=rleq
          vtol=1.0D-3
      else if(hasdiscrete) then
          vtol=1.0D-5
      else
          vtol=1.0D-5
      endif
      onegood=.FALSE.

C  Set input parameters.
c      RT = 0.85D0
c      NT=10
      MAX = .FALSE.
      EPS = 1.0D-6
      ISEED1 = 1
      ISEED2 = 2
      NS=10
c      NS=20
      if(100.GT.10*neq) then
          NTmax=100
      else
          NTmax=10*neq
      endif
      MAXEVL = 100 000 000 0
      IPRINT = 0
      call xbound(nx,LB,UB)

      NT=10
      nonew=0
      rtobj=1.0D20
      print *, " "

200   if(NT.LT.NTmax) then
          t=t0
          if(mSA.EQ.1) then
              do 60 i=1,nprt
                  do 65 j=1,neq
                      xx(i,j)=xx0(i,j)
65                continue
60            continue
          else
              do 15 i=1,neq
                  x(i)=x0(i)
15            continue
          endif
          do 10 i=1,nx
              C(I)=2.0D0
              VM(I)=0.1D0*(ub(i)-lb(i))
c              VM(I)=1.0D0
10        continue

          if(mSA.EQ.0) then
              CALL sa(NEQ,NC,rlambda,
     1           NX,X,MAX,RT,EPS,NS,NT,NEPS,MAXEVL,LB,UB,C,IPRINT,ISEED1,
     2           ISEED2,T,VM,XOPT,FOPT,NACC,NFCNEV,NOBDS,IER,
     3           FSTAR,XP,NACP)
          else if(mSA.EQ.1) then
              CALL psa(rlambda,
     1           NX,xx,MAX,RT,EPS,NS,NT,NEPS,MAXEVL,LB,UB,C,IPRINT,ISEED1,
     2           ISEED2,T,VM,XOPT,FOPT,NACC,NFCNEV,NOBDS,IER,
     3           FSTAR,xxp,NACP)
          else if(mSA.EQ.10) then
              CALL sa_equal(NEQ,NC,rlambda,xt,
     1           NX,X,MAX,RT,EPS,NS,NT,NEPS,MAXEVL,LB,UB,C,IPRINT,ISEED1,
     2           ISEED2,T,VM,XOPT,FOPT,NACC,NFCNEV,NOBDS,IER,
     3           FSTAR,XP,NACP)
              rleq=rleq0
          endif

          bstvio=sh_oviomax(xopt)
          msol1=0
          if(bstvio.LT.vtol) then
             msol1=1
             bstobj=sh_obj(nx,xopt)         
             do 50 i=1,neq
                 x(i)=xopt(i)
50           continue
             print *, "cSA: Obj =", bstobj, " vioMax =", bstvio, " at NT =", NT
             print *, "cSA: x =", (x(i)+xshift(i),i=1,nx)
          else
             print *, "cSA: Obj fails at NT =", NT
          endif
          call flush(6)

          msol2=0
c          if(msol1.EQ.1) call by_DLM(msol2,x,xobj,xvio,ni_used)
c          if(msol1.EQ.1) then
c              if(hasdiscrete) then
c                  call by_DLM(msol2,x,xobj,xvio,ni_used)
c              else
c                  call by_donlp2(msol2,x,xobj,xvio,ni_used)
c              endif
c          endif

          if(msol2.EQ.1) then
              xidist=0.0D0
              do 40 i=1,nx
                  if(abs(x(i)).LE.1.0D0) then
                      xidist=xidist+abs((x(i)-xopt(i)))
                  else
                      xidist=xidist+abs((x(i)-xopt(i))/x(i))
                  endif
40            continue
              if(xidist/nx.LT.0.1D0) then
                  msol=1
c                  print *,"DLM: Obj =",xobj," vioMax =",xvio," #iter =",ni_used
c                  print *,"DLM: x =", (x(i)+xshift(i),i=1,nx)
c                  if(hasdiscrete) then
c                      print *,"DLM: Obj =",xobj," vioMax =",xvio," #iter =",ni_used
c                      print *,"DLM: x =", (x(i)+xshift(i),i=1,nx)
c                  else
c                      print *,"SQP: Obj =",xobj," vioMax =",xvio," #iter =",ni_used
c                      print *,"SQP: x =", (x(i),i=1,nx)
c                  endif
                  print *,"xi distance = ", xidist/nx, "  at NT = ", NT
              else
                  msol=0
c                  print *,"DLM far from cSA"
c                  if(hasdiscrete) then
c                      print *,"DLM far from cSA"
c                  else
c                      print *,"SQP far from cSA"
c                  endif
              endif
c              if(bstobj.LT.xobj) then
c                  xobj=bstobj
c                  xvio=bstvio
c              endif
          else if(msol1.EQ.1) then
              msol=1
              xobj=bstobj
              xvio=bstvio
c              print *, "DLM: Obj fails "
c              if(hasdiscrete) then
c                  print *, "DLM: Obj fails "
c              else
c                  print *, "SQP: Obj fails "
c              endif
              do 25 i=1,neq
                  x(i)=xopt(i)
25            continue
          else
              msol=0
          endif

          if(msol.EQ.1) then
              dxobj=abs(rtobj-xobj) 
c              if(dxobj.GT.abs(rtobj)*1.0D-4.AND.dxobj.GT.1.0D-4) then
              if(dxobj.GT.abs(rtobj)*1.0D-4) then
                  nonew=0
                  if(xobj.LT.rtobj) then
                     rtobj=xobj
                     rtvio=xvio
                     do 30 i=1,neq
                         rtx(i)=x(i)
30                   continue
                     onegood=.TRUE.
                  endif
              else
                  nonew=nonew+1
                  if(nonew.GE.(nNT-1)) then
                      xobj=rtobj
                      xvio=rtvio
                      do 35 i=1,neq
                          x0(i)=rtx(i)
35                    continue
                      print *,"return Obj =",xobj," vioMax =",xvio, " NT =", NT
                      print *, "return x = ", (x0(i)+xshift(i),i=1,nx)
                      return
                  endif
              endif
          else
              nonew=0
          endif

          NT=NT*2
          goto 200
      endif

      if(onegood) then
         msol=1
         xobj=rtobj
         xvio=rtvio
         do 70 i=1,neq
             x0(i)=rtx(i)
70       continue
         print *,"return Obj =",xobj," vioMax =",xvio, " NT =", NT/2
         print *, "return x = ", (rtx(i)+xshift(i),i=1,nx)
      endif

      return
      END

